# Copyright (c) 2000-2007, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

%define section   free
%define cvsdate   070308
%define base_name ddlutils

Name:           db-%{base_name}
Version:        1.0
Release:        0.%{cvsdate}.1jpp
Epoch:          0
Summary:        DDL utilities

Group:          Development/Libraries/Java
License:        Apache Software License 2.0
URL:            http://db.apache.org/ddlutils/
Source0:        ddlutils-1.0-dev-070308.tar.gz
# svn export  http://svn.apache.org/repos/asf/db/ddlutils/trunk ddlutils
Source1:        DdlUtils-1.0-dev-doc.zip
# generated with forrest ...
Patch0:         db-ddlutils-1.0-build_xml.patch
Patch1:         db-ddlutils-1.0-jdbc.properties.hsqldb.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Distribution:   JPackage
Vendor:         JPackage Project

%if ! %{gcj_support}
BuildArch:      noarch
%endif
BuildRequires:  jpackage-utils >= 0:1.6
BuildRequires:  ant >= 0:1.6
# build-only
BuildRequires:  junit
BuildRequires:  hsqldb
# runtime
BuildRequires:  jakarta-commons-beanutils
BuildRequires:  jakarta-commons-betwixt0
BuildRequires:  jakarta-commons-codec
BuildRequires:  jakarta-commons-collections
BuildRequires:  jakarta-commons-dbcp
BuildRequires:  jakarta-commons-digester
BuildRequires:  jakarta-commons-lang
BuildRequires:  jakarta-commons-logging
BuildRequires:  jakarta-commons-pool
BuildRequires:  dom4j
BuildRequires:  jaxen
BuildRequires:  jakarta-oro
BuildRequires:  log4j
BuildRequires:  wstx
BuildRequires:  bea-stax

Requires:  jakarta-commons-beanutils
Requires:  jakarta-commons-betwixt0
Requires:  jakarta-commons-codec
Requires:  jakarta-commons-collections
Requires:  jakarta-commons-dbcp
Requires:  jakarta-commons-digester
Requires:  jakarta-commons-lang
Requires:  jakarta-commons-logging
Requires:  jakarta-commons-pool
Requires:  dom4j
Requires:  jaxen
Requires:  jakarta-oro
Requires:  log4j
Requires:  wstx
Requires:  bea-stax

%if %{gcj_support}
BuildRequires:    gnu-crypto
BuildRequires:    java-gcj-compat-devel
Requires(post):   java-gcj-compat
Requires(postun): java-gcj-compat
%endif

%description
DdlUtils is a small, easy-to-use component for working with 
Database Definition (DDL) files. These are XML files that contain 
the definition of a database schema, e.g. tables and columns. 
These files can be fed into DdlUtils via its Ant task or 
programmatically in order to create the corresponding database 
or alter it so that it corresponds to the DDL. Likewise, DdlUtils 
can generate a DDL file for an existing database.
DdlUtils uses the Turbine XML format, which is shared by Torque 
and OJB. This format expresses the database schema in a 
database-independent way by using JDBC datatypes instead of raw 
SQL datatypes which are inherently database specific.

%package        javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires(post):   /bin/rm,/bin/ln
Requires(postun): /bin/rm

%description    javadoc
%{summary}.

%package        manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description    manual
%{summary}.

%prep
%setup -q -n %{base_name}
for j in $(find . -name "*.jar"); do
    mv $j $j.no
done
unzip -qq %{SOURCE1}
rm -rf doc/api

%patch0 -b .sav
%patch1 -b .sav

%build
pushd lib
pushd build-only
ln -sf $(build-classpath ant)
ln -sf $(build-classpath junit)
popd
ln -sf $(build-classpath hsqldb)

ln -sf $(build-classpath wstx/wstx-asl)
ln -sf $(build-classpath log4j)
ln -sf $(build-classpath commons-logging)
ln -sf $(build-classpath commons-dbcp)
ln -sf $(build-classpath jakarta-oro)
ln -sf $(build-classpath commons-beanutils)
ln -sf $(build-classpath dom4j)
ln -sf $(build-classpath jaxen)
ln -sf $(build-classpath commons-pool)
ln -sf $(build-classpath commons-collections)
ln -sf $(build-classpath commons-codec)
ln -sf $(build-classpath commons-lang)
ln -sf $(build-classpath commons-digester)
ln -sf $(build-classpath commons-betwixt0)
ln -sf $(build-classpath bea-stax-api)
popd

ant \
    -Dtest.profile.directory=src/test-profiles \
    -Dprofile=mvdb \
    jar javadoc junit-hsqldb
# FIXME:  few unit tests failing now with hsqldb

%install
rm -rf $RPM_BUILD_ROOT
install -dm 755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 dist/DdlUtils-1.0-RC1.jar \
     $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
ln -s %{name}-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}.jar

#javadoc
install -dm 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/javadoc/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

#manual
install -dm 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr doc/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

%if %{gcj_support}
export CLASSPATH=$(build-classpath gnu-crypto)
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
    rm -f %{_javadocdir}/%{name}
fi

%if %{gcj_support}
%post
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(-,root,root,-)
%{_javadir}/*.jar
%doc LICENSE.txt
%if %{gcj_support}
%dir %attr(-,root,root) %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-%{version}.jar.*
%endif

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%files manual
%defattr(-,root,root,-)
%doc %{_docdir}/%{name}-%{version}

%changelog
* Thu Mar 08 2007 Ralph Apel <r.apel at r-apel.de> - 0:1.0-0.070308.1jpp
- First JPP-1.7 release
- Add gcj_support option
- Add manual subpackage

* Mon Feb 20 2006 Ralph Apel <r.apel at r-apel.de> - 0:1.0-0.060220.1jpp
- Pending fix of unit tests
